//
// C++ Implementation: pixmaps
//
// Author: Remi Villatel <maxilys@tele2.fr>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "pixmaps.h"
#include "serenityhandler.h"

#include <kdecoration.h>

#include <qapplication.h>
#include <qimage.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qwidget.h>

// Static declarations for linking.

QPixmap* Pixmaps::active_help_normal = 0;
QPixmap* Pixmaps::active_max_normal = 0;
QPixmap* Pixmaps::active_min_normal = 0;
QPixmap* Pixmaps::active_close_normal = 0;
QPixmap* Pixmaps::active_sticky_normal = 0;
QPixmap* Pixmaps::active_above_normal = 0;
QPixmap* Pixmaps::active_below_normal = 0;
QPixmap* Pixmaps::active_menu_normal = 0;

QPixmap* Pixmaps::active_help_hover = 0;
QPixmap* Pixmaps::active_max_hover = 0;
QPixmap* Pixmaps::active_min_hover = 0;
QPixmap* Pixmaps::active_close_hover = 0;
QPixmap* Pixmaps::active_sticky_hover = 0;
QPixmap* Pixmaps::active_above_hover = 0;
QPixmap* Pixmaps::active_below_hover = 0;
QPixmap* Pixmaps::active_menu_hover = 0;

QPixmap* Pixmaps::active_help_sunken = 0;
QPixmap* Pixmaps::active_max_sunken = 0;
QPixmap* Pixmaps::active_min_sunken = 0;
QPixmap* Pixmaps::active_close_sunken = 0;
QPixmap* Pixmaps::active_sticky_sunken = 0;
QPixmap* Pixmaps::active_above_sunken = 0;
QPixmap* Pixmaps::active_below_sunken = 0;
QPixmap* Pixmaps::active_menu_sunken = 0;

QPixmap* Pixmaps::inactive_help_normal = 0;
QPixmap* Pixmaps::inactive_max_normal = 0;
QPixmap* Pixmaps::inactive_min_normal = 0;
QPixmap* Pixmaps::inactive_close_normal = 0;
QPixmap* Pixmaps::inactive_sticky_normal = 0;
QPixmap* Pixmaps::inactive_above_normal = 0;
QPixmap* Pixmaps::inactive_below_normal = 0;
QPixmap* Pixmaps::inactive_menu_normal = 0;

QPixmap* Pixmaps::inactive_help_hover = 0;
QPixmap* Pixmaps::inactive_max_hover = 0;
QPixmap* Pixmaps::inactive_min_hover = 0;
QPixmap* Pixmaps::inactive_close_hover = 0;
QPixmap* Pixmaps::inactive_sticky_hover = 0;
QPixmap* Pixmaps::inactive_above_hover = 0;
QPixmap* Pixmaps::inactive_below_hover = 0;
QPixmap* Pixmaps::inactive_menu_hover = 0;

QPixmap* Pixmaps::inactive_help_sunken = 0;
QPixmap* Pixmaps::inactive_max_sunken = 0;
QPixmap* Pixmaps::inactive_min_sunken = 0;
QPixmap* Pixmaps::inactive_close_sunken = 0;
QPixmap* Pixmaps::inactive_sticky_sunken = 0;
QPixmap* Pixmaps::inactive_above_sunken = 0;
QPixmap* Pixmaps::inactive_below_sunken = 0;
QPixmap* Pixmaps::inactive_menu_sunken = 0;

bool Pixmaps::pixmapsCreated = false;

static int serene_help[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0x80,0x80,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,
	0x00,0x00,0x80,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0x80,0x00,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0x80,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x80,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int serene_max[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x80,0x80,0x80,0x80,0xC0,0xFF,0xFF,0xC0,0x80,0x80,0x80,0x80,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x00,0x80,0x80,0x80,0x80,0xC0,0xFF,0xFF,0xC0,0x80,0x80,0x80,0x80,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int serene_min[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int serene_close[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x40,0xFF,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xFF,0x40,0x00,0x00,
	0x00,0x00,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0x00,0x00,
	0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xC0,0x00,0x00,
	0x00,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xC0,0xC0,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xC0,0xC0,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0x00,
	0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xC0,0x00,0x00,
	0x00,0x00,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0x00,0x00,
	0x00,0x00,0x40,0xFF,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xFF,0x40,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int serene_sticky[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0xFF,0xC0,0x80,0x80,0xC0,0xFF,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x00,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x80,0x00,
	0x00,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0x00,
	0x00,0x80,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x80,0x00,
	0x00,0x00,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0x00,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0xFF,0xC0,0x80,0x80,0xC0,0xFF,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int serene_above[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0x00,
	0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xC0,0xFF,0xFF,0xC0,0xFF,0xFF,0xFF,0xC0,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0x40,0x80,0xFF,0xFF,0x80,0x40,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x40,0xFF,0xFF,0x40,0x00,0x80,0xFF,0xFF,0x80,0x00,0x40,0xFF,0xFF,0x40,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int serene_below[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x40,0xFF,0xFF,0x40,0x00,0x80,0xFF,0xFF,0x80,0x00,0x40,0xFF,0xFF,0x40,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0x40,0x80,0xFF,0xFF,0x80,0x40,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xC0,0xFF,0xFF,0xC0,0xFF,0xFF,0xFF,0xC0,0x00,0x00,
	0x00,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int serene_menu[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x80,0x00,0xC0,0xFF,0x40,0x00,0x00,0x40,0xFF,0xC0,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0x00,0xFF,0xFF,0x80,0x00,0x40,0xFF,0xFF,0xC0,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0xFF,0x00,0xFF,0xFF,0x80,0x40,0xFF,0xFF,0xC0,0x00,0x00,
	0x00,0x00,0xFF,0xFF,0xFF,0x40,0x00,0xFF,0xFF,0xC0,0xFF,0xFF,0xC0,0x00,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0x40,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,
	0x00,0xFF,0xFF,0xC0,0x00,0x00,0x00,0xFF,0xFF,0xC0,0xFF,0xFF,0xC0,0x00,0x00,0x00,
	0x00,0xFF,0xFF,0x80,0x00,0x00,0x00,0xFF,0xFF,0x80,0x40,0xFF,0xFF,0xC0,0x00,0x00,
	0x00,0xFF,0xFF,0x80,0x00,0x00,0x00,0xFF,0xFF,0x80,0x00,0x40,0xFF,0xFF,0xC0,0x00,
	0x00,0xFF,0xFF,0xC0,0x00,0x00,0x00,0xC0,0xFF,0x40,0x00,0x00,0x40,0xFF,0xC0,0x00,
	0x00,0x80,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0x00,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0xFF,0xC0,0x80,0x80,0xC0,0xFF,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

static int trinar_help[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x40,0x00,0x00,0x00,0x00,
	0x00,0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,
	0x00,0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,
	0x00,0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x80,0xFF,0xFF,0xFF,0x00,0xBF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,
	0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,
	0x00,0x00,0x40,0xFF,0xBF,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0x80,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int trinar_max[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x40,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0x40,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int trinar_min[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x40,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int trinar_close[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,
	0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x68,0x68,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x68,0x68,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,
	0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int trinar_sticky[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xE7,0xE7,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0x68,0x68,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x40,0xFF,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x40,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0x40,0x00,
	0x00,0xE7,0xFF,0xFF,0x68,0x00,0x00,0x00,0x00,0x00,0x00,0x68,0xFF,0xFF,0xE7,0x00,
	0x00,0xE7,0xFF,0xFF,0x68,0x00,0x00,0x00,0x00,0x00,0x00,0x68,0xFF,0xFF,0xE7,0x00,
	0x00,0x40,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0x40,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x40,0xFF,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0x68,0x68,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xE7,0xE7,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int trinar_above[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xE7,0xE7,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xE7,0xE7,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int trinar_below[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xE7,0xE7,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xE7,0xE7,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int trinar_menu[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,
	0x00,0xE7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE7,0x00,
	0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xE7,0xE7,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

static int powder_help[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x80,0xBF,0xFF,0xFF,0xBF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,
	0x00,0x00,0x00,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xBF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int powder_max[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,
	0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0xA0,0xA0,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0xA0,0xA0,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0xA0,0xA0,0x28,0x00,0x00,0x00,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0xA0,0xA0,0xA0,0xA0,0xA0,0x00,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x78,0xA0,0xA0,0xA0,0xA0,0x00,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,
	0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int powder_min[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x78,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0x78,0x00,
	0x00,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0x00,
	0x00,0xA0,0xA0,0x28,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x28,0xA0,0xA0,0x00,
	0x00,0xA0,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xA0,0xA0,0x00,
	0x00,0xA0,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xA0,0xA0,0x00,
	0x00,0x28,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xA0,0xA0,0x00,
	0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0xA0,0xA0,0x00,
	0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0xA0,0xA0,0x00,
	0x00,0xFF,0xFF,0x40,0x00,0x00,0x40,0xFF,0xFF,0x00,0x00,0x00,0x00,0xA0,0xA0,0x00,
	0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0xA0,0xA0,0x00,
	0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0xA0,0xA0,0x00,
	0x00,0xFF,0xFF,0x40,0x00,0x00,0x40,0xFF,0xFF,0x00,0x00,0x00,0x28,0xA0,0xA0,0x00,
	0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0xA0,0xA0,0xA0,0xA0,0xA0,0x00,
	0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x28,0xA0,0xA0,0xA0,0xA0,0x78,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int powder_close[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x40,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0x40,0x00,
	0x00,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0x00,
	0x00,0xBF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xBF,0x00,
	0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,
	0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xA8,0xA8,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xB8,0xB8,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0xA8,0xB8,0xA0,0xA0,0xB8,0xA8,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0xA8,0xB8,0xA0,0xA0,0xB8,0xA8,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xB8,0xB8,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xA8,0xA8,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,
	0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,
	0x00,0xBF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xBF,0x00,
	0x00,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0x00,
	0x00,0x40,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0x40,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int powder_sticky[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x28,0x80,0xFF,0xFF,0xFF,0xFF,0x80,0x28,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0xBF,0x40,0x00,0x00,0x40,0xBF,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x28,0xFF,0xFF,0x90,0x00,0x00,0x00,0x00,0x00,0x00,0x90,0xFF,0xFF,0x28,0x00,
	0x00,0x80,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0x80,0x00,
	0x00,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x00,
	0x00,0x80,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0x80,0x00,
	0x00,0x28,0xFF,0xFF,0x90,0x00,0x00,0x00,0x00,0x00,0x00,0x90,0xFF,0xFF,0x28,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0xBF,0x40,0x00,0x00,0x40,0xBF,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x28,0x80,0xFF,0xFF,0xFF,0xFF,0x80,0x28,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int powder_above[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xD0,0xD0,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x50,0x50,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x80,0xFF,0xD0,0x00,0x00,0xD0,0xFF,0x80,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0xFF,0xFF,0x50,0x00,0x00,0x50,0xFF,0xFF,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x80,0xFF,0xD0,0x00,0x00,0x00,0x00,0xD0,0xFF,0x80,0x00,0x00,0x00,
	0x00,0x00,0x00,0xFF,0xFF,0x50,0x00,0x00,0x00,0x00,0x50,0xFF,0xFF,0x00,0x00,0x00,
	0x00,0x00,0x80,0xFF,0xD0,0x00,0x00,0x00,0x00,0x00,0x00,0xD0,0xFF,0x80,0x00,0x00,
	0x00,0x00,0xFF,0xFF,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x50,0xFF,0xFF,0x00,0x00,
	0x00,0x80,0xFF,0xD0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xD0,0xFF,0x80,0x00,
	0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,
	0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int powder_below[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,
	0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,
	0x00,0x80,0xFF,0xD0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xD0,0xFF,0x80,0x00,
	0x00,0x00,0xFF,0xFF,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x50,0xFF,0xFF,0x00,0x00,
	0x00,0x00,0x80,0xFF,0xD0,0x00,0x00,0x00,0x00,0x00,0x00,0xD0,0xFF,0x80,0x00,0x00,
	0x00,0x00,0x00,0xFF,0xFF,0x50,0x00,0x00,0x00,0x00,0x50,0xFF,0xFF,0x00,0x00,0x00,
	0x00,0x00,0x00,0x80,0xFF,0xD0,0x00,0x00,0x00,0x00,0xD0,0xFF,0x80,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0xFF,0xFF,0x50,0x00,0x00,0x50,0xFF,0xFF,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x80,0xFF,0xD0,0x00,0x00,0xD0,0xFF,0x80,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x50,0x50,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xD0,0xD0,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int powder_menu[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0xBF,0xFF,0x80,0x00,
	0x00,0x00,0x00,0x58,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0xBF,0xFF,0xFF,0x40,0x00,
	0x00,0x00,0x58,0xB0,0x84,0xB0,0x00,0xFF,0xFF,0x00,0xBF,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x00,0x00,0x84,0xB0,0x84,0x00,0xFF,0xFF,0xBF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0xB0,0x84,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,
	0x00,0x00,0x58,0xB0,0x2C,0x00,0x00,0xFF,0xFF,0xBF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x84,0xB0,0xB0,0x00,0x00,0x00,0xFF,0xFF,0x00,0xBF,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x84,0xB0,0xB0,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0xBF,0xFF,0xFF,0x40,0x00,
	0x00,0x00,0x58,0xB0,0x2C,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0xBF,0xFF,0x80,0x00,
	0x00,0x00,0x00,0xB0,0x84,0x00,0x00,0x00,0x00,0x00,0x00,0x84,0x2C,0x00,0x00,0x00,
	0x00,0x00,0x00,0x84,0xB0,0x84,0x2C,0x00,0x00,0x2C,0x84,0xB0,0x84,0x00,0x00,0x00,
	0x00,0x00,0x58,0xB0,0x84,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0x84,0xB0,0x58,0x00,0x00,
	0x00,0x00,0x00,0x58,0x00,0x00,0x58,0xB0,0xB0,0x58,0x00,0x00,0x58,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x84,0x84,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

static int porcelain_help[] = {
	0x00,0x00,0x40,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x40,0x00,0x00,
	0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,
	0x80,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0x80,
	0x80,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,
	0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0xFF,0x80,
	0x00,0x00,0x40,0x80,0x80,0x80,0x80,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0xFF,0x80,
	0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0xFF,0x80,
	0x00,0x00,0x00,0x00,0x80,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,
	0x00,0x00,0x00,0x00,0x80,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0x80,
	0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0xBF,0x80,0x80,0x80,0x40,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x80,0xFF,0x40,0x00,0x00,0x40,0xFF,0x80,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x80,0xFF,0x40,0x00,0x00,0x40,0xFF,0x80,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x80,0x40,0x00,0x00,0x00,0x00,0x00,0x00
};
static int porcelain_max[] = {
	0x00,0x00,0x40,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x40,0x00,0x00,
	0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,
	0x40,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0x40,
	0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,
	0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,
	0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,
	0x80,0xFF,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xFF,0x80,
	0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,
	0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,
	0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,
	0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,
	0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,
	0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,
	0x40,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0x40,
	0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,
	0x00,0x00,0x40,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x40,0x00,0x00
};
static int porcelain_min[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x40,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x40,0x00,
	0x40,0xFF,0xBF,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xBF,0xFF,0x40,
	0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,
	0x80,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0x80,
	0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,
	0x00,0x00,0x40,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x40,0x00,0x00
};
static int porcelain_close[] = {
	0x00,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x40,0x00,0x00,
	0x00,0xBF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xBF,0x00,
	0x40,0xFF,0x40,0x40,0xBF,0xFF,0x40,0x00,0x00,0x40,0xFF,0xBF,0x40,0x40,0xFF,0x40,
	0x80,0xFF,0x40,0x00,0x00,0xBF,0xFF,0x40,0x40,0xFF,0xBF,0x00,0x00,0x40,0xFF,0x80,
	0x00,0xFF,0xBF,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0xBF,0xFF,0x00,
	0x00,0x40,0xFF,0xBF,0x00,0x00,0x00,0xBF,0xBF,0x00,0x00,0x00,0xBF,0xFF,0x40,0x00,
	0x00,0x00,0x40,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0x40,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xBF,0x00,0x00,0x00,0x00,0xBF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xBF,0x00,0x00,0x00,0x00,0xBF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x40,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0x40,0x00,0x00,
	0x00,0x40,0xFF,0xBF,0x00,0x00,0x00,0xBF,0xBF,0x00,0x00,0x00,0xBF,0xFF,0x40,0x00,
	0x00,0xFF,0xBF,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0xBF,0xFF,0x00,
	0x80,0xFF,0x40,0x00,0x00,0xBF,0xFF,0x40,0x40,0xFF,0xBF,0x00,0x00,0x40,0xFF,0x80,
	0x40,0xFF,0x40,0x40,0xBF,0xFF,0x40,0x00,0x00,0x40,0xFF,0xBF,0x40,0x40,0xFF,0x40,
	0x00,0xBF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xBF,0x00,
	0x00,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x40,0x00,0x00
};
static int porcelain_sticky[] = {
	0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x80,0x80,0x80,0x40,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0xBF,0x40,0x00,0x00,0x40,0xBF,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x40,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x40,0x00,
	0x00,0xBF,0xFF,0x40,0x00,0x40,0xBF,0xFF,0xFF,0xBF,0x40,0x00,0x40,0xFF,0xBF,0x00,
	0x40,0xFF,0xBF,0x00,0x40,0xFF,0xFF,0x80,0x80,0xFF,0xFF,0x40,0x00,0xBF,0xFF,0x40,
	0x80,0xFF,0x40,0x00,0xBF,0xFF,0x00,0x00,0x00,0x00,0xFF,0xBF,0x00,0x40,0xFF,0x80,
	0x80,0xFF,0x00,0x00,0xFF,0x80,0x00,0x00,0x00,0x00,0x80,0xFF,0x00,0x00,0xFF,0x80,
	0x80,0xFF,0x00,0x00,0xFF,0x80,0x00,0x00,0x00,0x00,0x80,0xFF,0x00,0x00,0xFF,0x80,
	0x80,0xFF,0x40,0x00,0xBF,0xFF,0x00,0x00,0x00,0x00,0xFF,0xBF,0x00,0x40,0xFF,0x80,
	0x40,0xFF,0xBF,0x00,0x40,0xFF,0xFF,0x80,0x80,0xFF,0xFF,0x40,0x00,0xBF,0xFF,0x40,
	0x00,0xBF,0xFF,0x40,0x00,0x40,0xBF,0xFF,0xFF,0xBF,0x40,0x00,0x40,0xFF,0xBF,0x00,
	0x00,0x40,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x40,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0xBF,0x40,0x00,0x00,0x40,0xBF,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x00,0x00,0x40,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x80,0x80,0x80,0x40,0x00,0x00,0x00,0x00,0x00
};
static int porcelain_above[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xBF,0xBF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x80,0xFF,0x80,0x00,0x00,0x80,0xFF,0x80,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,0x40,0x40,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x80,0xFF,0x80,0x00,0xBF,0xBF,0x00,0x80,0xFF,0x80,0x00,0x00,0x00,
	0x00,0x00,0x00,0xFF,0xFF,0x00,0x40,0xFF,0xFF,0x40,0x00,0xFF,0xFF,0x00,0x00,0x00,
	0x00,0x00,0x80,0xFF,0x80,0x00,0xBF,0x80,0x80,0xBF,0x00,0x80,0xFF,0x80,0x00,0x00,
	0x00,0x00,0xFF,0xFF,0x00,0x40,0xFF,0x00,0x00,0xFF,0x40,0x00,0xFF,0xFF,0x00,0x00,
	0x00,0x80,0xFF,0x80,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x80,0xFF,0x80,0x00,
	0x00,0xFF,0xFF,0x00,0x00,0x40,0x80,0x80,0x80,0x80,0x40,0x00,0x00,0xFF,0xFF,0x00,
	0x80,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x80,
	0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,
	0x00,0x40,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x40,0x00
};
static int porcelain_below[] = {
	0x00,0x40,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x40,0x00,
	0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,
	0x80,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x80,
	0x00,0xFF,0xFF,0x00,0x00,0x40,0x80,0x80,0x80,0x80,0x40,0x00,0x00,0xFF,0xFF,0x00,
	0x00,0x80,0xFF,0x80,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,0x80,0xFF,0x80,0x00,
	0x00,0x00,0xFF,0xFF,0x00,0x40,0xFF,0x00,0x00,0xFF,0x40,0x00,0xFF,0xFF,0x00,0x00,
	0x00,0x00,0x80,0xFF,0x80,0x00,0xBF,0x80,0x80,0xBF,0x00,0x80,0xFF,0x80,0x00,0x00,
	0x00,0x00,0x00,0xFF,0xFF,0x00,0x40,0xFF,0xFF,0x40,0x00,0xFF,0xFF,0x00,0x00,0x00,
	0x00,0x00,0x00,0x80,0xFF,0x80,0x00,0xBF,0xBF,0x00,0x80,0xFF,0x80,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,0x40,0x40,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x80,0xFF,0x80,0x00,0x00,0x80,0xFF,0x80,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xBF,0xBF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int porcelain_menu[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x40,0x00,0x00,
	0x00,0xBF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xBF,0x00,
	0x40,0xFF,0x40,0x40,0xBF,0xFF,0x40,0x00,0x00,0x40,0xFF,0xBF,0x40,0x40,0xFF,0x40,
	0x80,0xFF,0x40,0x00,0x00,0xBF,0xFF,0x40,0x40,0xFF,0xBF,0x00,0x00,0x40,0xFF,0x80,
	0x00,0xFF,0xBF,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xBF,0x00,0x00,0x00,0xBF,0xFF,0x00,
	0x00,0x40,0xFF,0xBF,0x00,0x00,0x00,0xBF,0xBF,0x00,0x00,0x00,0xBF,0xFF,0x40,0x00,
	0x00,0x00,0x40,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0x40,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xBF,0x00,0x00,0x00,0x00,0xBF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x40,0xFF,0xBF,0x00,0x00,0xBF,0xFF,0x40,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xBF,0xBF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

static int classic_help[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0xFF,0xFF,0xBF,0x40,0x00,0x00,0x40,0xBF,0xFF,0xFF,0x00,0x00,0x00,
	0x00,0x00,0x80,0xFF,0xBF,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0x80,0x00,0x00,
	0x00,0x00,0x40,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0x80,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0x80,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xBF,0xFF,0xFF,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0xBF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xDF,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x20,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int classic_max[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0x80,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int classic_min[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,
	0x00,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x00,
	0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int classic_close[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0xBF,0xDF,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0xDF,0xBF,0x00,0x00,
	0x00,0x00,0xDF,0xFF,0xDF,0x20,0x00,0x00,0x00,0x00,0x20,0xDF,0xFF,0xDF,0x00,0x00,
	0x00,0x00,0x20,0xDF,0xFF,0xDF,0x20,0x00,0x00,0x20,0xDF,0xFF,0xDF,0x20,0x00,0x00,
	0x00,0x00,0x00,0x20,0xDF,0xFF,0xDF,0x20,0x20,0xDF,0xFF,0xDF,0x20,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x20,0xDF,0xFF,0xDF,0xDF,0xFF,0xDF,0x20,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x20,0xDF,0xFF,0xFF,0xDF,0x20,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x20,0xDF,0xFF,0xFF,0xDF,0x20,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x20,0xDF,0xFF,0xDF,0xDF,0xFF,0xDF,0x20,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x20,0xDF,0xFF,0xDF,0x20,0x20,0xDF,0xFF,0xDF,0x20,0x00,0x00,0x00,
	0x00,0x00,0x20,0xDF,0xFF,0xDF,0x20,0x00,0x00,0x20,0xDF,0xFF,0xDF,0x20,0x00,0x00,
	0x00,0x00,0xDF,0xFF,0xDF,0x20,0x00,0x00,0x00,0x00,0x20,0xDF,0xFF,0xDF,0x00,0x00,
	0x00,0x00,0xBF,0xDF,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0xDF,0xBF,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int classic_sticky[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x80,0xDF,0xFF,0xFF,0xDF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0xA0,0x20,0x00,0x00,0x20,0xA0,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x00,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x00,0x00,
	0x00,0x80,0xFF,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xA0,0xFF,0x80,0x00,
	0x00,0xDF,0xFF,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0xFF,0xDF,0x00,
	0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,
	0x00,0xDF,0xFF,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0xFF,0xDF,0x00,
	0x00,0x80,0xFF,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xA0,0xFF,0x80,0x00,
	0x00,0x00,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x00,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0xA0,0x20,0x00,0x00,0x20,0xA0,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x80,0xDF,0xFF,0xFF,0xDF,0x80,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int classic_above[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x80,0x80,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0x80,0x00,0x00,0x80,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x40,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x40,0x00,
	0x00,0x40,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0x40,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int classic_below[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x40,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0x40,0x00,
	0x00,0x40,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x40,0x00,
	0x00,0x00,0x40,0xFF,0xFF,0x80,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x40,0x00,0x00,
	0x00,0x00,0x00,0x40,0xFF,0xFF,0x80,0x00,0x00,0x80,0xFF,0xFF,0x40,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x80,0x80,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xFF,0xFF,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static int classic_menu[] = {
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,
	0x00,0xBF,0xBF,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0xBF,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,
	0x00,0xFF,0xFF,0xFF,0xBF,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
	0x00,0xFF,0xFF,0xFF,0xBF,0x00,0xFF,0x00,0x80,0x80,0x80,0x80,0x80,0x00,0xFF,0x00,
	0x00,0xFF,0xFF,0xBF,0x00,0x00,0xFF,0x00,0x80,0x80,0x80,0x80,0x80,0x00,0xFF,0x00,
	0x00,0xBF,0xBF,0x00,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x80,0x80,0x80,0x80,0x80,0x00,0xFF,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x80,0x80,0x80,0x80,0x80,0x00,0xFF,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x80,0x80,0x80,0x80,0x80,0x00,0xFF,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x80,0x80,0x80,0x80,0x80,0x00,0xFF,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x20,0x00,0x00,0x00,0x00,0x00,0x20,0xFF,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

void Pixmaps::createPixmaps()
{
	if (pixmapsCreated)
		return;

	static int* alias_pix[8];
	if (SerenityHandler::iconTheme() == 4)
	{
		alias_pix[0] = classic_help;
		alias_pix[1] = classic_max;
		alias_pix[2] = classic_min;
		alias_pix[3] = classic_close;
		alias_pix[4] = classic_sticky;
		alias_pix[5] = classic_above;
		alias_pix[6] = classic_below;
		alias_pix[7] = classic_menu;
	}
	else if (SerenityHandler::iconTheme() == 3)
	{
		alias_pix[0] = trinar_help;
		alias_pix[1] = trinar_max;
		alias_pix[2] = trinar_min;
		alias_pix[3] = trinar_close;
		alias_pix[4] = trinar_sticky;
		alias_pix[5] = trinar_above;
		alias_pix[6] = trinar_below;
		alias_pix[7] = trinar_menu;
	}
	else if (SerenityHandler::iconTheme() == 2)
	{
		alias_pix[0] = porcelain_help;
		alias_pix[1] = porcelain_max;
		alias_pix[2] = porcelain_min;
		alias_pix[3] = porcelain_close;
		alias_pix[4] = porcelain_sticky;
		alias_pix[5] = porcelain_above;
		alias_pix[6] = porcelain_below;
		alias_pix[7] = porcelain_menu;
	}
	else if (SerenityHandler::iconTheme() == 1)
	{
		alias_pix[0] = powder_help;
		alias_pix[1] = powder_max;
		alias_pix[2] = powder_min;
		alias_pix[3] = powder_close;
		alias_pix[4] = powder_sticky;
		alias_pix[5] = powder_above;
		alias_pix[6] = powder_below;
		alias_pix[7] = powder_menu;
	}
	else	// (SerenityHandler::iconTheme() == 0)
	{
		alias_pix[0] = serene_help;
		alias_pix[1] = serene_max;
		alias_pix[2] = serene_min;
		alias_pix[3] = serene_close;
		alias_pix[4] = serene_sticky;
		alias_pix[5] = serene_above;
		alias_pix[6] = serene_below;
		alias_pix[7] = serene_menu;
	}

	bool indexWide[] = 
	{
		SerenityHandler::helpWide(), 
		SerenityHandler::maxWide(), 
		SerenityHandler::minWide(), 
		SerenityHandler::closeWide(), 
		SerenityHandler::stickyWide(), 
		SerenityHandler::aboveWide(), 
		SerenityHandler::belowWide(), 
		SerenityHandler::menuWide()
	};

	int indexGlow[] = 
	{
		SerenityHandler::helpGlow(), 
		SerenityHandler::maxGlow(), 
		SerenityHandler::minGlow(), 
		SerenityHandler::closeGlow(), 
		SerenityHandler::stickyGlow(), 
		SerenityHandler::aboveGlow(), 
		SerenityHandler::belowGlow(), 
		SerenityHandler::menuGlow()
	};

	int buttonSize = SerenityHandler::buttonSize();

	// MXLS: Palette
	QPalette pal = QApplication::palette();
	QColor aFont = KDecoration::options()->color(KDecoration::ColorFont, true);
	QColor iFont = KDecoration::options()->color(KDecoration::ColorFont, false);
	QColor ground = pal.color(QPalette::Active, QColorGroup::Background);
	QColor aTitlebar = KDecoration::options()->color(KDecoration::ColorTitleBar, true);
	QColor iTitlebar = KDecoration::options()->color(KDecoration::ColorTitleBar, false);
	QColor hilite = pal.color( QPalette::Active, QColorGroup::Highlight );
	QColor aSurface = Qt::white, iSurface = Qt::white;
	bool aCarved = false;
	bool iCarved = false;
	if (SerenityHandler::buttonStyle() == 2)
	{
		aSurface = colorMix(ground, 
					pal.color(QPalette::Active, QColorGroup::Foreground)
					,216);
		iSurface = aSurface;
	}
	else if (SerenityHandler::buttonStyle() == 3)
	{
		aSurface = aTitlebar;
		iSurface = iTitlebar;
	}
	else if (SerenityHandler::buttonStyle() == 4)
	{
		aSurface = colorMix(ground, aTitlebar, 160);
		aCarved = true;
		iSurface = colorMix(ground, iTitlebar, 160);
		iCarved = true;
	}
	if (qGray(aSurface.rgb()) < 64)
		aSurface = aSurface.light(150);
	if (qGray(iSurface.rgb()) < 64)
		iSurface = iSurface.light(150);
		
	// Lotsa work to do.
	// Zero...
	static QPixmap* active_normal[8];
	static QPixmap* active_hover[8];
	static QPixmap* active_sunken[8];
	static QPixmap* inactive_normal[8];
	static QPixmap* inactive_hover[8];
	static QPixmap* inactive_sunken[8];
	// Forty eight!
	static QPainter an_painter, ah_painter, as_painter,
			in_painter, ih_painter, is_painter;
	static QRect an_rect, ah_rect, as_rect,
			in_rect, ih_rect, is_rect;
	QColor glow;
	int currentWidth;
	int buttonStyle = SerenityHandler::buttonStyle();
	// Some colors to use.
	int atR, atG, atB;		// Active title text color
	aFont.getRgb(&atR, &atG, &atB);
	int itR, itG, itB;		// Inactive title text color
	iFont.getRgb(&itR, &itG, &itB);

	// Zero...
	for (int btn=0 ; btn<8 ; btn++)
	{
		glow = SerenityHandler::listColor(indexGlow[btn]);
		currentWidth = indexWide[btn] ? buttonSize*3/2 : buttonSize;
		if (currentWidth & 1)	// Odd size
			currentWidth++;
		//
		active_normal[btn] = new QPixmap(currentWidth, buttonSize);
		an_rect = active_normal[btn]->rect();
		an_painter.begin(active_normal[btn]);
		an_painter.fillRect(an_rect, ground);
		//
		inactive_normal[btn] = new QPixmap(currentWidth, buttonSize);
		in_rect = inactive_normal[btn]->rect();
		in_painter.begin(inactive_normal[btn]);
		in_painter.fillRect(in_rect, ground);
		//
		if (buttonStyle == 0)
		{
			renderSurface(&an_painter, an_rect, ground, 
						aTitlebar, aTitlebar, 0);
			renderSurface(&in_painter, in_rect, ground, 
						iTitlebar, iTitlebar, 0);
		}
		else if ( (buttonStyle == 5) || (buttonStyle == 6) )
		{
			renderSurface(&an_painter, an_rect, ground, 
						aTitlebar, glow, 1);
			renderSurface(&in_painter, in_rect, ground, 
						iTitlebar, glow, 1);
		}
		else if ( (buttonStyle > 1) && (buttonStyle != 7) )
		{
			if (aCarved)
			{
				renderCarving(&an_painter, an_rect, 
						ground, aSurface);
			}
			else
			{
				renderFlatArea(&an_painter, an_rect, 
						ground, aSurface);
			}
			if (iCarved)
			{
				renderCarving(&in_painter, in_rect, 
						ground, iSurface);
			}
			else
			{
				renderFlatArea(&in_painter, in_rect, 
						ground, iSurface);
			}
		}
		//
		active_hover[btn] = new QPixmap(currentWidth, buttonSize);
		ah_rect = active_hover[btn]->rect();
		ah_painter.begin(active_hover[btn]);
		ah_painter.fillRect(ah_rect, ground);
		//
		inactive_hover[btn] = new QPixmap(currentWidth, buttonSize);
		ih_rect = inactive_hover[btn]->rect();
		ih_painter.begin(inactive_hover[btn]);
		ih_painter.fillRect(ih_rect, ground);
		//
		if ( (buttonStyle == 0) || (buttonStyle == 5) || (buttonStyle == 6) )
		{
			renderSurface(&ah_painter, ah_rect, ground, 
				aTitlebar, glow, 1);
			renderSurface(&ih_painter, ih_rect, ground, 
				iTitlebar, glow, 1);
		}
		else if ( (buttonStyle == 1) || (buttonStyle == 7) )
		{
			renderSurface(&ah_painter, ah_rect, ground, 
				ground, glow, 1);
			renderSurface(&ih_painter, ih_rect, ground, 
				ground, glow, 1);
		}
		else 
		{
			renderSurface(&ah_painter, ah_rect, ground, 
				aSurface, glow, 1);
			renderSurface(&ih_painter, ih_rect, ground, 
				iSurface, glow, 1);
		}
		//
		active_sunken[btn] = new QPixmap(currentWidth, buttonSize);
		as_rect = active_sunken[btn]->rect();
		as_painter.begin(active_sunken[btn]);
		as_painter.fillRect(as_rect, ground);
		//
		inactive_sunken[btn] = new QPixmap(currentWidth, buttonSize);
		is_rect = inactive_sunken[btn]->rect();
		is_painter.begin(inactive_sunken[btn]);
		is_painter.fillRect(is_rect, ground);
		//
		if ( (buttonStyle == 1) || (buttonStyle == 7) )
		{
			renderSurface(&as_painter, as_rect, ground, 
				ground, hilite, 2);
			renderSurface(&is_painter, is_rect, ground, 
				ground, hilite, 2);
		}
		else 
		{
			renderSurface(&as_painter, as_rect, ground, 
				aTitlebar, hilite, 2);
			renderSurface(&is_painter, is_rect, ground, 
				iTitlebar, hilite, 2);
		}
		int ofX = (currentWidth - 16)/2;
		int ofY = (buttonSize-16)/2;
		QImage* temp_icon = new QImage(16, 16, 32);
		QImage* temp_ground = new QImage();
		//
		if ( (btn==7) && (SerenityHandler::styledMenu()==false) )
		{
			// No icon there but keep the button background.
		}
		else
		{
			if (buttonStyle != 5)
			{
				int aR = atR;
				int aG = atG;
				int aB = atB;
				int iR = itR;
				int iG = itG;
				int iB = itB;
				QColor aColor, iColor;
				if (buttonStyle == 6)
				{
					aColor = colorMix( colorMix(aTitlebar, aFont, 192), glow);
					aColor.getRgb(&aR, &aG, &aB);
					iColor = colorMix( colorMix(iTitlebar, iFont, 192), glow);
					iColor.getRgb(&iR, &iG, &iB);
				}
				else if (buttonStyle == 7)
				{
					aColor = colorMix(aFont, glow);
					aColor.getRgb(&aR, &aG, &aB);
					iColor = colorMix(iFont, glow);
					iColor.getRgb(&iR, &iG, &iB);
				}
				*temp_ground = active_normal[btn]->convertToImage();
				*temp_ground = temp_ground->convertDepth(32);
				bitBlt(temp_icon, 0, 0, temp_ground, ofX, ofY, 16, 16, 0);
				unicity(alias_pix[btn], *temp_icon, aR, aG, aB);
				bitBlt(active_normal[btn], ofX, ofY, temp_icon, 0, 0, 16, 16, 0);
				*temp_ground = inactive_normal[btn]->convertToImage();
				*temp_ground = temp_ground->convertDepth(32);
				bitBlt(temp_icon, 0, 0, temp_ground, ofX, ofY, 16, 16, 0);
				unicity(alias_pix[btn], *temp_icon, iR, iG, iB);
				bitBlt(inactive_normal[btn], ofX, ofY, temp_icon, 0, 0, 16, 16, 0);
			}
			//
			*temp_ground = active_hover[btn]->convertToImage();
			*temp_ground = temp_ground->convertDepth(32);
			bitBlt(temp_icon, 0, 0, temp_ground, ofX, ofY, 16, 16, 0);
			unicity(alias_pix[btn], *temp_icon, atR, atG, atB);
			bitBlt(active_hover[btn], ofX, ofY, temp_icon, 0, 0, 16, 16, 0);
			*temp_ground = inactive_hover[btn]->convertToImage();
			*temp_ground = temp_ground->convertDepth(32);
			bitBlt(temp_icon, 0, 0, temp_ground, ofX, ofY, 16, 16, 0);
			unicity(alias_pix[btn], *temp_icon, itR, itG, itB);
			bitBlt(inactive_hover[btn], ofX, ofY, temp_icon, 0, 0, 16, 16, 0);
			//
			*temp_ground = active_sunken[btn]->convertToImage();
			*temp_ground = temp_ground->convertDepth(32);
			bitBlt(temp_icon, 0, 0, temp_ground, ofX, ofY, 16, 16, 0);
			unicity(alias_pix[btn], *temp_icon, atR, atG, atB);
			bitBlt(active_sunken[btn], ofX, ofY, temp_icon, 0, 0, 16, 16, 0);
			*temp_ground = inactive_sunken[btn]->convertToImage();
			*temp_ground = temp_ground->convertDepth(32);
			bitBlt(temp_icon, 0, 0, temp_ground, ofX, ofY, 16, 16, 0);
			unicity(alias_pix[btn], *temp_icon, itR, itG, itB);
			bitBlt(inactive_sunken[btn], ofX, ofY, temp_icon, 0, 0, 16, 16, 0);
		}
		an_painter.end();
		in_painter.end();
		ah_painter.end();
		ih_painter.end();
		as_painter.end();
		is_painter.end();
		delete temp_icon;
		delete temp_ground;
	}
	// Forty eight... This is the end.
	// Well, almost!
	// Zero...
	active_help_normal = active_normal[0];
	active_max_normal = active_normal[1];
	active_min_normal = active_normal[2];
	active_close_normal = active_normal[3];
	active_sticky_normal = active_normal[4];
	active_above_normal = active_normal[5];
	active_below_normal = active_normal[6];
	active_menu_normal = active_normal[7];
	// Eight...
	active_help_hover = active_hover[0];
	active_max_hover = active_hover[1];
	active_min_hover = active_hover[2];
	active_close_hover = active_hover[3];
	active_sticky_hover = active_hover[4];
	active_above_hover = active_hover[5];
	active_below_hover = active_hover[6];
	active_menu_hover = active_hover[7];
	// Sixteen...
	active_help_sunken = active_sunken[0];
	active_max_sunken = active_sunken[1];
	active_min_sunken = active_sunken[2];
	active_close_sunken = active_sunken[3];
	active_sticky_sunken = active_sunken[4];
	active_above_sunken = active_sunken[5];
	active_below_sunken = active_sunken[6];
	active_menu_sunken = active_sunken[7];
	// Twenty four...
	inactive_help_normal = inactive_normal[0];
	inactive_max_normal = inactive_normal[1];
	inactive_min_normal = inactive_normal[2];
	inactive_close_normal = inactive_normal[3];
	inactive_sticky_normal = inactive_normal[4];
	inactive_above_normal = inactive_normal[5];
	inactive_below_normal = inactive_normal[6];
	inactive_menu_normal = inactive_normal[7];
	// Thirty two...
	inactive_help_hover = inactive_hover[0];
	inactive_max_hover = inactive_hover[1];
	inactive_min_hover = inactive_hover[2];
	inactive_close_hover = inactive_hover[3];
	inactive_sticky_hover = inactive_hover[4];
	inactive_above_hover = inactive_hover[5];
	inactive_below_hover = inactive_hover[6];
	inactive_menu_hover = inactive_hover[7];
	// Forty...
	inactive_help_sunken = inactive_sunken[0];
	inactive_max_sunken = inactive_sunken[1];
	inactive_min_sunken = inactive_sunken[2];
	inactive_close_sunken = inactive_sunken[3];
	inactive_sticky_sunken = inactive_sunken[4];
	inactive_above_sunken = inactive_sunken[5];
	inactive_below_sunken = inactive_sunken[6];
	inactive_menu_sunken = inactive_sunken[7];
	// Forty eight. We're done!
}

void Pixmaps::deletePixmaps()
{
	delete active_help_normal;
	active_help_normal = 0;
	delete active_max_normal;
	active_max_normal = 0;
	delete active_min_normal;
	active_min_normal = 0;
	delete active_close_normal;
	active_close_normal = 0;
	delete active_sticky_normal;
	active_sticky_normal = 0;
	delete active_above_normal;
	active_above_normal = 0;
	delete active_below_normal;
	active_below_normal = 0;
	delete active_menu_normal;
	active_menu_normal = 0;
	
	delete active_help_hover;
	active_help_hover = 0;
	delete active_max_hover;
	active_max_hover = 0;
	delete active_min_hover;
	active_min_hover = 0;
	delete active_close_hover;
	active_close_hover = 0;
	delete active_sticky_hover;
	active_sticky_hover = 0;
	delete active_above_hover;
	active_above_hover = 0;
	delete active_below_hover;
	active_below_hover = 0;
	delete active_menu_hover;
	active_menu_hover = 0;
	
	delete active_help_sunken;
	active_help_sunken = 0;
	delete active_max_sunken;
	active_max_sunken = 0;
	delete active_min_sunken;
	active_min_sunken = 0;
	delete active_close_sunken;
	active_close_sunken = 0;
	delete active_sticky_sunken;
	active_sticky_sunken = 0;
	delete active_above_sunken;
	active_above_sunken = 0;
	delete active_below_sunken;
	active_below_sunken = 0;
	delete active_menu_sunken;
	active_menu_sunken = 0;

	delete inactive_help_normal;
	inactive_help_normal = 0;
	delete inactive_max_normal;
	inactive_max_normal = 0;
	delete inactive_min_normal;
	inactive_min_normal = 0;
	delete inactive_close_normal;
	inactive_close_normal = 0;
	delete inactive_sticky_normal;
	inactive_sticky_normal = 0;
	delete inactive_above_normal;
	inactive_above_normal = 0;
	delete inactive_below_normal;
	inactive_below_normal = 0;
	delete inactive_menu_normal;
	inactive_menu_normal = 0;
	
	delete inactive_help_hover;
	inactive_help_hover = 0;
	delete inactive_max_hover;
	inactive_max_hover = 0;
	delete inactive_min_hover;
	inactive_min_hover = 0;
	delete inactive_close_hover;
	inactive_close_hover = 0;
	delete inactive_sticky_hover;
	inactive_sticky_hover = 0;
	delete inactive_above_hover;
	inactive_above_hover = 0;
	delete inactive_below_hover;
	inactive_below_hover = 0;
	delete inactive_menu_hover;
	inactive_menu_hover = 0;
	
	delete inactive_help_sunken;
	inactive_help_sunken = 0;
	delete inactive_max_sunken;
	inactive_max_sunken = 0;
	delete inactive_min_sunken;
	inactive_min_sunken = 0;
	delete inactive_close_sunken;
	inactive_close_sunken = 0;
	delete inactive_sticky_sunken;
	inactive_sticky_sunken = 0;
	delete inactive_above_sunken;
	inactive_above_sunken = 0;
	delete inactive_below_sunken;
	inactive_below_sunken = 0;
	delete inactive_menu_sunken;
	inactive_menu_sunken = 0;

	pixmapsCreated = false;
}

void Pixmaps::unicity(int* pattern, QImage& work, int rr, int gg, int bb)
{
	int x, y, aa, zz;
	int z = 0;
	uint pxl;
	for (y=0; y<16; y++)
	{
		uint *line = (uint*)work.scanLine(y);	// work is 32-bit QImage.
		for (x=0; x<16; x++)
		{
			aa = pattern[z];	// Pattern is (16*16) * 256 levels
			//
			if (aa == 255)	// Replace background with color.
			{
				line[x] = qRgb(rr, gg, bb);
			}
			else if (aa != 0)			// Otherwise mix.
			{
				pxl = line[x];
				zz = 255-aa;
				line[x] = qRgb( (qRed(pxl)*zz + rr*aa) / 255, 
						(qGreen(pxl)*zz + gg*aa) / 255, 
						(qBlue(pxl)*zz + bb*aa) / 255 );
			}
			// else keep background.
			z++;
		}
	}
}

QColor Pixmaps::colorMix(QColor bgColor, QColor fgColor, int alpha)
{
	// Unnecessary since alpha is always a constant.
	//if (alpha > 255) alpha = 255;
	//if (alpha < 0) alpha = 0;
	int bred, bgrn, bblu, fred, fgrn, fblu;
	bgColor.getRgb(&bred, &bgrn, &bblu);
	fgColor.getRgb(&fred, &fgrn, &fblu);
	return QColor( fred + ((bred-fred)*alpha)/255,
			fgrn + ((bgrn-fgrn)*alpha)/255,
			fblu + ((bblu-fblu)*alpha)/255 );
}

void Pixmaps::renderGradient(QPainter* painter, 
				const QRect &rect, 
				const QColor &c1, 
				const QColor &c2, 
				const int direction, 
				const bool convex)
{
	if ( (rect.width() <= 0) || (rect.height() <= 0) )
		return;
	
	int width = rect.width();
	int height = rect.height();
	
	QColor first, last;
	if (convex)
	{
		first = c1;
		last = c2;
	}
	else	// Exchange colors.
	{
		first = c2;
		last = c1;
	}
	int fR, fG, fB;		// first RGB components
	first.getRgb(&fR, &fG, &fB);
	int lR, lG, lB;		// last RGB components
	last.getRgb(&lR, &lG, &lB);
	//
	float rr = (float)fR;	// Start color
	float gg = (float)fG;
	float bb = (float)fB;
	//
	// Where to draw our gradient.
	QImage* result = new QImage(width, height, 32);
	//
	float deltaR, deltaG, deltaB;
	register int x, y;
	unsigned int* line;
	if (direction == VerticalGradient)
	{
		deltaR = (float) (lR-fR)/height;
		deltaG = (float) (lG-fG)/height;
		deltaB = (float) (lB-fB)/height;
		int color;
		for (y = 0; y < height; y++) 
		{
			line = (unsigned int*)(result->scanLine(y));
			color = qRgb( (int)rr, (int)gg, (int)bb );
			for (x = 0; x < width; x++) 
			{
				line[x] = color;
			}
			rr += deltaR;
			gg += deltaG;
			bb += deltaB;
		}
	}
	else
	{
		deltaR = (float) (lR-fR)/width;
		deltaG = (float) (lG-fG)/width;
		deltaB = (float) (lB-fB)/width;
		line = (unsigned int*)(result->scanLine(0));
		for (x = 0; x < width; x++) 
		{
			line[x] = qRgb( (int)rr, (int)gg, (int)bb );
			rr += deltaR;
			gg += deltaG;
			bb += deltaB;
		}
		unsigned int* src;
		unsigned int* dst;
		for (y = 1; y < height; y++) 
		{
			src = line;
			dst = (unsigned int*)(result->scanLine(y));
			for (x = 0; x < width; x++) 
			{
				*dst++ = *src++;
			}
		}
	}
	//
	painter->drawImage(rect, *result);
	delete result;
}

void Pixmaps::renderDiagonalGradient(QPainter* painter, 
					const QRect &rect, 
					const QColor &top, 
					const QColor &middle, 
					const QColor &bottom, 
					const bool convex)
{
	if ( (rect.width() <= 0) || (rect.height() <= 0) )
		return;
	
	int width = rect.width();
	int height = rect.height();
	
	QColor first, last;
	if (convex)
	{
		first = top;
		last = bottom;
	}
	else	// Exchange colors.
	{
		first = bottom;
		last = top;
	}
	int tR, tG, tB;		// top RGB components
	first.getRgb(&tR, &tG, &tB);
	int mR, mG, mB;		// middle RGB components
	middle.getRgb(&mR, &mG, &mB);
	int bR, bG, bB;		// bottom RGB components
	last.getRgb(&bR, &bG, &bB);
	//
	float ldR = (float) (mR-tR)/height;	// On the left,
	float ldG = (float) (mG-tG)/height;	// color goes 
	float ldB = (float) (mB-tB)/height;	// from "first" to "middle".
	float rdR = (float) (bR-mR)/height;	// On the right,
	float rdG = (float) (bG-mG)/height;	// color goes 
	float rdB = (float) (bB-mB)/height;	// from "middle" to "last".
	//
	float leftR = (float)tR;	// top left color
	float leftG = (float)tG;
	float leftB = (float)tB;
	float rightR = (float)mR;	// top right color
	float rightG = (float)mG;
	float rightB = (float)mB;
	//
	// Where to draw our gradient.
	QImage* result = new QImage(width, height, 32);
	//
	register int x, y;
	float rr, gg, bb;
	float deltaR, deltaG, deltaB;
	unsigned int* line;
	float w = (float)width;
	for (y = 0; y < height; y++) 
	{
		rr = leftR;
		gg = leftG;
		bb = leftB;
		deltaR = (rightR-leftR)/w;	// Horizontal delta(s)
		deltaG = (rightG-leftG)/w;
		deltaB = (rightB-leftB)/w;
		line = (unsigned int*)(result->scanLine(y));
		for (x = 0; x < width; x++) 
		{
			line[x] = qRgb( (int)rr, (int)gg, (int)bb );
			rr += deltaR;
			gg += deltaG;
			bb += deltaB;
		}
		leftR += ldR;	// Left vertical delta(s)
		leftG += ldG;
		leftB += ldB;
		rightR += rdR;	// Right vertical delta(s)
		rightG += rdG;
		rightB += rdB;
	}
	//
	painter->drawImage(rect, *result);
	delete result;
}

void Pixmaps::renderSpecialCorner(QPainter* p, 
				const int x, 
				const int y, 
				const int size, 
				const QColor &top, 
				const QColor &middle, 
				const QColor &bottom)
{
	int yy = y;
	QRegion tlr(x, y, size, size);
	QRegion brr(x, y, size, size);
	for (int s=size; s>0; s--)
	{
		tlr -= QRegion(x+s-1, y+size-s+1, 1, s);
		brr -= QRegion(x, yy, s, 1);
		yy++;
		
	}
	p->setClipRegion(tlr);
	renderGradient(p, QRect(x, y, size, size), 
			middle, top, 
			HorizontalGradient);
	p->setClipRegion(brr);
	renderGradient(p, QRect(x, y, size, size), 
			bottom, middle, 
			VerticalGradient);
	p->setClipping(false);
}

void Pixmaps::renderSquareGradient(QPainter* painter, 
				const QRect &rect, 
				const QColor &topleft, 
				const QColor &middle, 
				const QColor &bottomright, 
				const bool convex)
{
	if ( (rect.width() <= 0) || (rect.height() <= 0) )
		return;
	
	// Some useful values
	int left, top, right, bottom;
	rect.coords(&left, &top, &right, &bottom);
	int width, height;
	rect.rect(&left, &top, &width, &height);

	int x1, y1, x2, y2;
	x1 = left+7;
	y1 = top+7;
	x2 = right-6;
	y2 = bottom-6;
	
	QColor first, last;
	if (convex)
	{
		first = topleft;
		last = bottomright;
	}
	else	// Exchange colors.
	{
		first = bottomright;
		last = topleft;
	}
	if ( (width > 14) && (height > 14) )
	{
		painter->fillRect(x1, y1, width-14, height-14, QBrush(middle));
	}
	if (width > 14)
	{
		renderGradient(painter, QRect(x1, top, width-14, 7),
				first, middle, VerticalGradient);
		renderGradient(painter, QRect(x1, y2, width-14, 7),
				middle, last, VerticalGradient);
	}
	if (height > 14)
	{
		renderGradient(painter, QRect(left, y1, 7, height-14),
				first, middle, HorizontalGradient);
		renderGradient(painter, QRect(x2, y1, 7, height-14),
				middle, last, HorizontalGradient);
	}
	renderDiagonalGradient(painter, QRect(left, top, 7, 7), 
				first, first, middle);
	renderDiagonalGradient(painter, QRect(x2, top, 7, 7), 
				first, middle, last);
	renderDiagonalGradient(painter, QRect(left, y2, 7, 7), 
				first, middle, last);
	renderDiagonalGradient(painter, QRect(x2, y2, 7, 7), 
				middle, last, last);
}

void Pixmaps::renderSurface(QPainter *p,
				 QRect r,
				 QColor backgroundColor,
				 QColor surfaceColor,
				 QColor highlightColor,
				 uint flags)
{
	const int SRN_DOWN = 144;	// Sunken effect
	const int SRN_OVER = 192;	// Hover effect
	//
	bool highlight = flags&1;	// Is_Highlight == 1
	bool sunken = flags&2;		// Is_Sunken == 2
	bool convex = true;
	int contrast = SerenityHandler::gradientContrast();

	QColor baseColor = surfaceColor;
	if (sunken)
	{
		if (! SerenityHandler::alternateSinking() )
			convex = false;
		baseColor = colorMix(baseColor, highlightColor, SRN_DOWN);
	}
	else if (highlight)
	{
		baseColor = colorMix(baseColor, highlightColor, SRN_OVER);
	}

	// Some useful values
	int left, top, right, bottom;
	r.coords(&left, &top, &right, &bottom);
	int width, height;
	r.rect(&left, &top, &width, &height);
	
	// Re-calculated base colors and surface
	QColor borderTop, borderBottom;
	borderTop = sunken ? baseColor.dark(100+contrast*5) 
				: baseColor.light(100+contrast*4);
	borderBottom = sunken ? baseColor.light(100+contrast*4)
				: baseColor.dark(100+contrast*5);
	QColor gradientTop, gradientBottom;
	gradientTop = baseColor.light(100+contrast*3);
	gradientBottom = baseColor.dark(100+contrast*3);
	
	// Draw surface
	if (SerenityHandler::gradientType() == 1)
	{
		renderSquareGradient(p, QRect(left+1, top+1, width-2, height-2),
					gradientTop, baseColor, gradientBottom, 
					convex);
	}
	else if (SerenityHandler::gradientType() == 2)
	{
		p->fillRect( QRect(left+1, top+1, width-2, height-2), QBrush(baseColor) );
	}
	else	// gradientType() == 0
	{
		renderDiagonalGradient(p, QRect(left+1, top+1, width-2, height-2),
					gradientTop, baseColor, gradientBottom, 
					convex);
	}
	// Draw sides
	//
	QRect leftBorder = QRect(left, top+2, 1, height-4);
	QRect rightBorder = QRect(right, top+2, 1, height-4);
	QRect topBorder = QRect(left+2, top, width-4, 1);
	QRect bottomBorder = QRect(left+2, bottom, width-4, 1);

	// The borders in between the corners
	if (SerenityHandler::gradientType() != 1)
	{
		renderGradient(p, leftBorder, 
				borderTop, baseColor, VerticalGradient);
		renderGradient(p, rightBorder,
				baseColor, borderBottom, VerticalGradient);
		renderGradient(p, topBorder,
				borderTop, baseColor, HorizontalGradient);
		renderGradient(p, bottomBorder,
				baseColor, borderBottom, HorizontalGradient);
	}
	else
	{
		p->setPen(borderTop);
		p->drawLine(topBorder.left(), topBorder.y(), 
				topBorder.right(), topBorder.y());
		p->drawLine(leftBorder.x(), leftBorder.top(), 
				leftBorder.x(), leftBorder.bottom());
		p->setPen(borderBottom);
		p->drawLine(rightBorder.x(), rightBorder.top(), 
				rightBorder.x(), rightBorder.bottom());
		p->drawLine(bottomBorder.left(), bottomBorder.y(), 
				bottomBorder.right(), bottomBorder.y());
	}

	// The antialiased corners
	// Top left
	p->setPen(borderTop);
	p->drawPoint(left+1, top+1);
	p->setPen( colorMix(backgroundColor, borderTop) );
	p->drawPoint(left+1, top);
	p->drawPoint(left, top+1);
	// Top right
	p->setPen( colorMix(backgroundColor, baseColor) );
	p->drawPoint(right-1, top);
	p->drawPoint(right, top+1);
	// Bottom left
	p->setPen( colorMix(backgroundColor, baseColor) );
	p->drawPoint(left+1, bottom);
	p->drawPoint(left, bottom-1);
	// Bottom Right
	p->setPen(borderBottom);
	p->drawPoint(right-1, bottom-1);
	p->setPen( colorMix(backgroundColor, borderBottom) );
	p->drawPoint(right-1, bottom);
	p->drawPoint(right, bottom-1);
	// Fill the corners
	p->setPen(backgroundColor);
	p->drawPoint(left, top);
	p->drawPoint(right, top);
	p->drawPoint(left, bottom);
	p->drawPoint(right, bottom);
}

void Pixmaps::renderFlatArea(QPainter* p,
			 	QRect r,
			 	QColor backgroundColor,
			 	QColor surfaceColor)
{
	// Some useful values
	int left, top, right, bottom;
	r.coords(&left, &top, &right, &bottom);
	
	QColor aliased = colorMix(backgroundColor, surfaceColor);
	
	p->fillRect(r, QBrush(surfaceColor) );
	// Round corners
	p->setPen(aliased);
	p->drawPoint(left+1, top);
	p->drawPoint(left, top+1);
	p->drawPoint(right-1, top);
	p->drawPoint(right, top+1);
	p->drawPoint(left+1, bottom);
	p->drawPoint(left, bottom-1);
	p->drawPoint(right-1, bottom);
	p->drawPoint(right, bottom-1);
	// Fill the corners
	p->setPen(backgroundColor);
	p->drawPoint(left, top);
	p->drawPoint(right, top);
	p->drawPoint(left, bottom);
	p->drawPoint(right, bottom);
}

void Pixmaps::renderSereneContour(QPainter* p,
					QRect r,
					QColor backgroundColor,
					QColor contour,
					uint flags)
{
	int contrast = SerenityHandler::gradientContrast();
	const bool sunken = flags&2; 		// Is_Sunken == 2
	const bool all_round = flags&0x10;	// All_Round == 0x10
	
	// Re-calculated base colors
	QColor borderTop, borderBottom;
	borderTop = sunken ? contour.dark(100+contrast*5) 
				: contour.light(100+contrast*4);
	borderBottom = sunken ? contour.light(100+contrast*4)
				: contour.dark(100+contrast*5);
	QColor baseColor = contour;
	QColor aliasedTop = colorMix(backgroundColor, borderTop);
	QColor aliasedBottom = colorMix(backgroundColor, borderBottom);
	QColor aliased = colorMix(backgroundColor, baseColor);
	
	// Some useful values
	int left, top, right, bottom;
	r.coords(&left, &top, &right, &bottom);
	int width = r.width()-2;
	int height = r.height()-2;

	QRect leftBorder(left, top+1, 1, height);
	QRect rightBorder(right, top+1, 1, height);
	QRect topBorder(left+1, top, width, 1);
	QRect bottomBorder(left+1, bottom, width, 1);

	// First the antialiased corners.
	// We do it this way to avoid some if's.
	if (all_round)
	{
		leftBorder.addCoords(0, 1, 0, 0);	// top+1
		topBorder.addCoords(1, 0, 0, 0);	// left+1
		// Round corner
		p->setPen(borderTop);
		p->drawPoint(left+1, top+1);
		// Anti-aliasing
		p->setPen(aliasedTop);
		p->drawPoint(left+1, top);
		p->drawPoint(left, top+1);
		// And beyond
		p->setPen(backgroundColor);
		p->drawPoint(left, top);
	}
	else
	{
		// Square corner
		p->setPen(aliasedTop);
		p->drawPoint(left, top);
	}
	if (all_round)
	{
		rightBorder.addCoords(0, 1, 0, 0);	// top+1
		topBorder.addCoords(0, 0, -1, 0);	// right-1
		// Round corner
		p->setPen(baseColor);
		p->drawPoint(right-1, top+1);
		// Anti-aliasing
		p->setPen(aliased);
		p->drawPoint(right-1, top);
		p->drawPoint(right, top+1);
		// And beyond
		p->setPen(backgroundColor);
		p->drawPoint(right, top);
	}
	else
	{
		// Square corner
		p->setPen(aliased);
		p->drawPoint(right, top);
	}
	if (all_round)
	{
		leftBorder.addCoords(0, 0, 0, -1);	// bottom-1
		bottomBorder.addCoords(1, 0, 0, 0);	// left+1
		// Round corner
		p->setPen(baseColor);
		p->drawPoint(left+1, bottom-1);
		// Anti-aliasing
		p->setPen(aliased);
		p->drawPoint(left+1, bottom);
		p->drawPoint(left, bottom-1);
		// And beyond
		p->setPen(backgroundColor);
		p->drawPoint(left, bottom);
	}
	else
	{
		// Square corner
		p->setPen(aliased);
		p->drawPoint(left, bottom);
	}
	if (all_round)
	{
		rightBorder.addCoords(0, 0, 0, -1);	// bottom-1
		bottomBorder.addCoords(0, 0, -1, 0);	// right-1
		// Round corner
		p->setPen(borderBottom);
		p->drawPoint(right-1, bottom-1);
		// Anti-aliasing
		p->setPen(aliasedBottom);
		p->drawPoint(right-1, bottom);
		p->drawPoint(right, bottom-1);
		// And beyond
		p->setPen(backgroundColor);
		p->drawPoint(right, bottom);
	}
	else
	{
		// Square corner
		p->setPen(aliasedBottom);
		p->drawPoint(right, bottom);
	}
	// The borders
	renderGradient(p, leftBorder, 
			borderTop, baseColor, VerticalGradient);
	renderGradient(p, rightBorder,
			baseColor, borderBottom, VerticalGradient);
	renderGradient(p, topBorder,
			borderTop, baseColor, HorizontalGradient);
	renderGradient(p, bottomBorder,
			baseColor, borderBottom, HorizontalGradient);
}

void Pixmaps::renderCarving(QPainter* p,
				QRect r,
				QColor backgroundColor,
				QColor contour)
{
	QRect inner(r);
	inner.addCoords(1, 1, -1, -1);
	renderSereneContour(p, inner, backgroundColor, contour, 0); // Square and raised
	renderSereneContour(p, r, backgroundColor, contour, 0x12); // Round and sunken
}

